public class Pascal {
	
	public static void main(String[] args) {
		long[] pascalBad = pascalBadRek(27);
		for(long l : pascalBad)
			System.out.print(l + " ");
		
		System.out.println();
		
		long[] pascalNice = pascalNiceRek(27);
		for(long l : pascalNice)
			System.out.print(l + " ");
		
		System.out.println();
		
		long[] pascalNiceNext = pascalNextLine(pascalNice);
		for(long l : pascalNiceNext)
			System.out.print(l + " ");
	}
	
	public static long[] pascalBadRek(int n) {
		long[] result = new long[n+1];
		for(int k = 0; k <= n; k++) {
			result[k] = pascalBadRekH(n, k);
		}
		
		return result;
	}
	
	private static long pascalBadRekH(int n, int k) {
		if(n < 0 || k < 0 || k > n) {
			return 0;
		} else if(n == 0 && k == 0) {
			return 1;
		} else {
			return pascalBadRekH(n - 1, k - 1) + pascalBadRekH(n - 1, k);
		}
	}
	
	public static long[] pascalNiceRek(int n) {
		long[] result = new long[n+1];		
		long[][] dd = new long[n+1][n+1];
		
		for(int k = 0; k <= n; k++) {
			result[k] = pascalNiceRekH(dd, n, k);
		}
		
		return result;
	}
	
	private static long pascalNiceRekH(long[][] dd, int n, int k) {
		if(n < 0 || k < 0 || k > n) {
			return 0;
		} else if(n == 0 && k == 0) {
			return 1;
		}
		
		if(dd[n][k] == 0) {
			dd[n][k] = pascalNiceRekH(dd, n - 1, k - 1) + pascalNiceRekH(dd, n - 1, k);
		}
		
		return dd[n][k];
	}
	
	public static long[] pascalNextLine(long[] current) {
		long[] result = new long[current.length + 1];
		
		result[0] = 1;
		result[result.length - 1] = 1;
		
		for(int i = 1; i < result.length - 1; i++) {
			result[i] = current[i - 1] + current[i];
		}
		
		return result;
	}
}
